searchNodes=[{"doc":"A library that can generate OHLC(open, high, low, close) candles from trade events. It supports multiple timeframes including minute, hour, day and week and different configuration options opts/0 . Installation The package can be installed by adding ohlc to your list of dependencies in mix.exs : def deps do [ { :ohlc , &quot;~&gt; 1.2&quot; } ] end Example usage iex&gt; trades = [ ...&gt; [ price : 12.21 , volume : 0.98 , time : 1616439921 ] , ...&gt; [ price : 12.54 , volume : 12.1 , time : 1616439931 ] , ...&gt; [ price : 12.56 , volume : 18.3 , time : 1616439952 ] , ...&gt; [ price : 18.9 , volume : 12 , time : 1616440004 ] , ...&gt; [ price : 11 , volume : 43.1 , time : 1616440025 ] , ...&gt; [ price : 18.322 , volume : 43.1 , time : 1616440028 ] ...&gt; ] ...&gt; ...&gt; OHLC . create_candles ( trades , :minute ) { :ok , %{ candles : [ %{ close : 12.56 , etime : 1616439959 , high : 12.56 , low : 12.21 , open : 12.21 , processed : true , stime : 1616439900 , trades : 3 , type : :bullish , volume : 31.38 } , %{ close : 18.9 , etime : 1616440019 , high : 18.9 , low : 18.9 , open : 18.9 , processed : true , stime : 1616439960 , trades : 1 , type : :bearish , volume : 12.0 } , %{ close : 18.322 , etime : 1616440079 , high : 18.322 , low : 11.0 , open : 11.0 , processed : true , stime : 1616440020 , trades : 2 , type : :bullish , volume : 86.2 } ] , pair : nil , timeframe : :minute } }","ref":"OHLC.html","title":"OHLC","type":"module"},{"doc":"Coverts candles to new timeframe. Parameters: candles - A list of candles. timeframe - Must be higher then the existing candles timeframe. For example if candles were previously created using :hour timeframe then the provided timeframe cannot be :minute. Returns a tuple containing the list of candles with converted timeframe. Example iex&gt; trades = [ ...&gt; [ price : 0.12 , volume : 542.98 , time : 1668108995 ] , ...&gt; [ price : 0.14 , volume : 212.1 , time : 1668108998 ] , ...&gt; [ price : 0.17 , volume : 532.77 , time : 1668112595 ] , ...&gt; [ price : 0.21 , volume : 123.8 , time : 1668112623 ] ...&gt; ] ...&gt; ...&gt; { :ok , %{ candles : candles } } = OHLC . create_candles ( trades , :minute ) ...&gt; OHLC . convert_timeframe ( candles , :day ) { :ok , [ %{ close : 0.21 , etime : 1668124799 , high : 0.21 , low : 0.12 , open : 0.12 , processed : true , stime : 1668038400 , trades : 4 , type : :bullish , volume : 1411.65 } ] }","ref":"OHLC.html#convert_timeframe/2","title":"OHLC.convert_timeframe/2","type":"function"},{"doc":"Function for generating candles from trades and timeframe provided. Parameters: trades/0 - A list containing all the trades. Trades must be chronologically arranged(ASC) by the timestamp field. timeframe/0 - Timeframe for the candles. opts/0 - Option values for the data proccessing. Returns a tuple containing the metadata for the candles and a list of generated candles. Example iex&gt; trades = [ ...&gt; [ price : 0.12 , volume : 542.98 , time : 1668108995 ] , ...&gt; [ price : 0.14 , volume : 212.1 , time : 1668108998 ] , ...&gt; [ price : 0.17 , volume : 532.77 , time : 1668112595 ] , ...&gt; [ price : 0.21 , volume : 123.8 , time : 1668112623 ] ...&gt; ] ...&gt; ...&gt; OHLC . create_candles ( trades , :hour , [ pair : &quot;BTC/EUR&quot; , validate_trades : true ] ) { :ok , %{ candles : [ %{ close : 0.14 , etime : 1668110399 , high : 0.14 , low : 0.12 , open : 0.12 , processed : true , stime : 1668106800 , trades : 2 , type : :bullish , volume : 755.08 } , %{ close : 0.21 , etime : 1668113999 , high : 0.21 , low : 0.17 , open : 0.17 , processed : true , stime : 1668110400 , trades : 2 , type : :bullish , volume : 656.57 } ] , pair : &quot;BTC/EUR&quot; , timeframe : :hour } }","ref":"OHLC.html#create_candles/3","title":"OHLC.create_candles/3","type":"function"},{"doc":"Merges candle into another candle. If main candles :stime is 0 then fallback to the merge_child :stime . Parameters: main_candle - Candle which will be merged into. child_candle - Candle which will be merged. It is important to have etime less than or equal to the main candle. Meaning both candles should stay in the same timeframe. Example iex&gt; trades1 = [ ...&gt; [ price : 0.12 , volume : 542.98 , time : 1668108995 ] , ...&gt; [ price : 0.14 , volume : 212.1 , time : 1668108998 ] ...&gt; ] ...&gt; trades2 = [ ...&gt; [ price : 0.17 , volume : 532.77 , time : 1668112595 ] , ...&gt; [ price : 0.21 , volume : 123.8 , time : 1668112623 ] ...&gt; ] ...&gt; { :ok , %{ candles : candles1 } } = OHLC . create_candles ( trades1 , :week ) ...&gt; { :ok , %{ candles : candles2 } } = OHLC . create_candles ( trades2 , :week ) ...&gt; OHLC . merge_child ( List . first ( candles1 ) , List . first ( candles2 ) ) { :ok , %{ close : 0.21 , etime : 1668383999 , high : 0.21 , low : 0.12 , open : 0.12 , processed : true , stime : 1667779200 , trades : 4 , type : :bullish , volume : 1411.65 } }","ref":"OHLC.html#merge_child/2","title":"OHLC.merge_child/2","type":"function"},{"doc":"Single candle generated.","ref":"OHLC.html#t:candle/0","title":"OHLC.candle/0","type":"type"},{"doc":"A list of candles.","ref":"OHLC.html#t:candles/0","title":"OHLC.candles/0","type":"type"},{"doc":"Available options for create_candles/3 :forward_fill - When set true copies the previous candles closing price to the next candle if no trades happened to be in between. Useful when you don't want to get empty time gap between the generated candles. :validate_trades - When set true all trades are being validated before generating the candles to avoid errors and misinformation. :previous_candle - Trades are appended to the previous candle if possible before generating the new candles. Useful if you want to update existing candle. :pair - Adds the asset pair name to the returned outputs metadata.","ref":"OHLC.html#t:opts/0","title":"OHLC.opts/0","type":"type"},{"doc":"Available timeframes for create_candles/3","ref":"OHLC.html#t:timeframe/0","title":"OHLC.timeframe/0","type":"type"},{"doc":"Single trade.","ref":"OHLC.html#t:trade/0","title":"OHLC.trade/0","type":"type"},{"doc":"A list of trades.","ref":"OHLC.html#t:trades/0","title":"OHLC.trades/0","type":"type"},{"doc":"This module provides functionality to generate random or defined OHLC candles or trades which can be used for testing, demoing etc.","ref":"OHLCFactory.html","title":"OHLCFactory","type":"module"},{"doc":"Generates candles based on parameters provided. Parameters: timeframe - See available timeframes OHLCHelper.get_timeframes . amount - Amount of candles to generate. Must be bigger than 0. Available options: :base_price - Base price to use when generating candles. Defaults to 9. :price_direction - Generated candles can increase or decrease in price. :increase , :decrease or :rand which is used by default. :price_change_percentage - With each new candle we dynamically update the price for each new candle. This price can be higher than the previous candle or lesser. With this option you can choose the percentage change for each new candle. Defaults to 2% change with each new candle.","ref":"OHLCFactory.html#gen_candles/3","title":"OHLCFactory.gen_candles/3","type":"function"},{"doc":"Generates empty OHLC candle. If provided with timeframe stime and etime will be generated based on current time.","ref":"OHLCFactory.html#gen_empty_candle/1","title":"OHLCFactory.gen_empty_candle/1","type":"function"},{"doc":"Generates trades from provided arguments. Options: timeframe - Timeframe used for rounding the timestamp. Available values are: :minute , :hour , :day , :week min_price - The minimum price on the generated trades max_price - The maximum price on the generated trades volume - The volume each trade has timeframe_multiplier - If you'd like to generate less trades per candle then you can increase the size of the timeframe_divider parameter(1-100) otherwise leave empty. timeframe_divider - Is used for generating multiple candles of the same timeframe.","ref":"OHLCFactory.html#gen_trades/1","title":"OHLCFactory.gen_trades/1","type":"function"},{"doc":"OHLC Helper module containing all the helper functions.","ref":"OHLCHelper.html","title":"OHLCHelper","type":"module"},{"doc":"Helper function for formatting the value to float.","ref":"OHLCHelper.html#format_to_float/1","title":"OHLCHelper.format_to_float/1","type":"function"},{"doc":"Generates trades from provided arguments. Parameters: timeframe - Timeframe used for rounding the timestamp. Available values are: :minute , :hour , :day , :week min_price - The minimum price on the generated trades max_price - The maximum price on the generated trades volume - The volume each trade has timeframe_multiplier - If you'd like to generate less trades per candle then you can increase the size of the timeframe_divider parameter(1-100) otherwise leave empty. timeframe_divider - Is used for generating multiple candles of the same timeframe.","ref":"OHLCHelper.html#gen_trades/6","title":"OHLCHelper.gen_trades/6","type":"function"},{"doc":"Generates and returns empty candle. If provided with timeframe stime and etime will be generated based on current time.","ref":"OHLCHelper.html#generate_empty_candle/1","title":"OHLCHelper.generate_empty_candle/1","type":"function"},{"doc":"Gets the current candle type(pullish or bearish). Returns :bullish - if close price &gt; open price. bearish - if previous close price &lt;= open price.","ref":"OHLCHelper.html#get_candle_type/2","title":"OHLCHelper.get_candle_type/2","type":"function"},{"doc":"Gets the rounded timestamp based on the timeframe. Parameters: timestamp - Unix timestamp which will be rounded. timeframe - Timeframe used for rounding the timestamp. Available values are: :minute , :hour , :day , :week opts - Options for rounding the timestamp. Available values are: {:format, :stamp | :struct} - Returned value will be unix timestamp or DateTime struct. {:type, :down | :up | :jump} - Timestamp will be rounded up, down or jump to the next time cycle. Default is :up .","ref":"OHLCHelper.html#get_time_rounded/3","title":"OHLCHelper.get_time_rounded/3","type":"function"},{"doc":"Returns all available timeframes in seconds.","ref":"OHLCHelper.html#get_timeframes/0","title":"OHLCHelper.get_timeframes/0","type":"function"},{"doc":"Calculates the total volume from trades.","ref":"OHLCHelper.html#trades_total_volume/1","title":"OHLCHelper.trades_total_volume/1","type":"function"},{"doc":"Validates the data used for generating the OHLC candles. Accepts lists of candles, trades or both.","ref":"OHLCHelper.html#validate_data/2","title":"OHLCHelper.validate_data/2","type":"function"},{"doc":"A library that can generate OHLC(open, high, low, close) candles from trade events. It supports multiple timeframes including minute, hour, day and week and different configuration options OHLC.opts() . All generated dates and times are in UTC +0 timezone. The library is using the built in module DateTime which handles the timezones. OHLC library also provides helper functions when working with OHLC data. Please look at the available modules and their functions in the documentation: https://hexdocs.pm/ohlc This library could be useful if you want to create your own charting engine or trading bot.","ref":"readme.html","title":"OHLC","type":"extras"},{"doc":"The package can be installed by adding ohlc to your list of dependencies in mix.exs : def deps do [ { :ohlc , &quot;~&gt; 1.2&quot; } ] end","ref":"readme.html#installation","title":"OHLC - Installation","type":"extras"},{"doc":"iex&gt; trades = [ ...&gt; [ price : 12.21 , volume : 0.98 , time : 1616439921 ] , ...&gt; [ price : 12.54 , volume : 12.1 , time : 1616439931 ] , ...&gt; [ price : 12.56 , volume : 18.3 , time : 1616439952 ] , ...&gt; [ price : 18.9 , volume : 12 , time : 1616440004 ] , ...&gt; [ price : 11 , volume : 43.1 , time : 1616440025 ] , ...&gt; [ price : 18.322 , volume : 43.1 , time : 1616440028 ] ...&gt; ] ...&gt; ...&gt; OHLC . create_candles ( trades , :minute ) { :ok , %{ candles : [ %{ close : 12.56 , etime : 1616439959 , high : 12.56 , low : 12.21 , open : 12.21 , processed : true , stime : 1616439900 , trades : 3 , type : :bullish , volume : 31.38 } , %{ close : 18.9 , etime : 1616440019 , high : 18.9 , low : 18.9 , open : 18.9 , processed : true , stime : 1616439960 , trades : 1 , type : :bearish , volume : 12.0 } , %{ close : 18.322 , etime : 1616440079 , high : 18.322 , low : 11.0 , open : 11.0 , processed : true , stime : 1616440020 , trades : 2 , type : :bullish , volume : 86.2 } ] , pair : nil , timeframe : :minute } }","ref":"readme.html#example-usage","title":"OHLC - Example usage","type":"extras"}]